
package core.dataview;

import core.gui.InputPanel;
import core.gui.TableController;
import java.awt.Component;
import java.sql.PreparedStatement;
import javax.swing.JPanel;


/**
 *
 * @author  PRAM WEE
 */
public class BeanDataView extends JPanel {

    private static final int TOOLBAR_OK_CANCEL = 0;
    private static final int TOOLBAR_BROWSE = 1;
    private String tableName = "";
    private PreparedStatement prepStmt = null;
    private int toolbarMode = TOOLBAR_BROWSE;

    public void browse() {
        tblData.getSelectionModel().setSelectionInterval(0, 0);
        dataController.setState(TableController.STATE_BROWSE);
    }

    public PreparedStatement getPrepStmt() {
        return prepStmt;
    }

    public void refresh() {
        dataController.loadTable();
    }

    public void setInputPanel(InputPanel inputPanel) {
        dataController.setInputPanel(inputPanel);
        if(inputPanel!=null)inputPanel.setTableController(dataController);
    }

    public void setPrepStmt(PreparedStatement prepStmt) {
        dataController.setPrepStmt(prepStmt);
    }

    public String getQuery() {
        return query;
    }

    public void setQuery(String query) {
        this.query = query;
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
        dataController.setTableName(tableName);
    }
    private String query = "";
    //private InputPanel inputPanel = null;
    private TableController dataController = null;

    public TableController getDataController() {
        return dataController;
    }

    public BeanDataView() {
        initComponents();
        dataController = new TableController(this, tableName, prepStmt, tblData, null, true); // Versi PrepStmt
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblData = new javax.swing.JTable();
        tbarUtama = new javax.swing.JToolBar();
        btnTambah = new javax.swing.JButton();
        btnUbah = new javax.swing.JButton();
        btnHapus = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        btnRefresh = new javax.swing.JButton();
        btnSemua = new javax.swing.JToggleButton();
        btnFilter = new javax.swing.JToggleButton();
        btnRefresh1 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        btnRefresh2 = new javax.swing.JButton();
        btnRefresh3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        btnRefresh4 = new javax.swing.JButton();

        jScrollPane1.setBorder(null);

        tblData.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblData.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblDataMouseClicked(evt);
            }
        });
        tblData.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                tblDataKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(tblData);

        tbarUtama.setFloatable(false);
        tbarUtama.setRollover(true);

        btnTambah.setMnemonic('t');
        btnTambah.setText("Tambah");
        btnTambah.setFocusable(false);
        btnTambah.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnTambah.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnTambah.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnTambahActionPerformed(evt);
            }
        });
        tbarUtama.add(btnTambah);

        btnUbah.setMnemonic('u');
        btnUbah.setText("Ubah");
        btnUbah.setFocusable(false);
        btnUbah.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnUbah.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnUbah.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnUbahActionPerformed(evt);
            }
        });
        tbarUtama.add(btnUbah);

        btnHapus.setMnemonic('h');
        btnHapus.setText("Hapus");
        btnHapus.setFocusable(false);
        btnHapus.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnHapus.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnHapus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnHapusActionPerformed(evt);
            }
        });
        tbarUtama.add(btnHapus);

        jLabel1.setText("|");
        tbarUtama.add(jLabel1);

        btnRefresh.setMnemonic('r');
        btnRefresh.setText("Refresh");
        btnRefresh.setFocusable(false);
        btnRefresh.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRefresh.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefreshActionPerformed(evt);
            }
        });
        tbarUtama.add(btnRefresh);

        buttonGroup1.add(btnSemua);
        btnSemua.setMnemonic('s');
        btnSemua.setText("Semua");
        btnSemua.setFocusable(false);
        btnSemua.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnSemua.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnSemua);

        buttonGroup1.add(btnFilter);
        btnFilter.setMnemonic('f');
        btnFilter.setText("Filter");
        btnFilter.setFocusable(false);
        btnFilter.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnFilter.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnFilter);

        btnRefresh1.setMnemonic('g');
        btnRefresh1.setText("Grup");
        btnRefresh1.setFocusable(false);
        btnRefresh1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRefresh1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnRefresh1);

        jLabel2.setText("|");
        tbarUtama.add(jLabel2);

        btnRefresh2.setMnemonic('i');
        btnRefresh2.setText("Import");
        btnRefresh2.setFocusable(false);
        btnRefresh2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRefresh2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnRefresh2);

        btnRefresh3.setMnemonic('e');
        btnRefresh3.setText("Export");
        btnRefresh3.setFocusable(false);
        btnRefresh3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRefresh3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnRefresh3);

        jLabel3.setText("|");
        tbarUtama.add(jLabel3);

        btnRefresh4.setMnemonic('p');
        btnRefresh4.setText("Tutup");
        btnRefresh4.setFocusable(false);
        btnRefresh4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnRefresh4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbarUtama.add(btnRefresh4);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 636, Short.MAX_VALUE)
                    .addComponent(tbarUtama, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 636, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(tbarUtama, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    private void switchToolbar(int toolbarMode) {
        this.toolbarMode = toolbarMode;
        Component[] cmps = tbarUtama.getComponents();

        switch (toolbarMode) {
            case TOOLBAR_OK_CANCEL:
                btnTambah.setText("Simpan");
                btnTambah.setMnemonic('s');
                btnUbah.setText("Batal");
                btnTambah.setMnemonic('b');

                for (int i = 0; i < cmps.length; i++) {
                    cmps[i].setVisible(false);
                }
                btnUbah.setVisible(true);
                btnTambah.setVisible(true);
                break;
            case TOOLBAR_BROWSE:
                btnTambah.setText("Tambah");
                btnTambah.setMnemonic('t');
                btnUbah.setText("Ubah");
                btnTambah.setMnemonic('u');
                for (int i = 0; i < cmps.length; i++) {
                    cmps[i].setVisible(true);
                }
                break;
        }
    }

    private void tblDataMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblDataMouseClicked
        dataController.fillInputPanel();
}//GEN-LAST:event_tblDataMouseClicked

    private void tblDataKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tblDataKeyPressed
        dataController.fillInputPanel();
}//GEN-LAST:event_tblDataKeyPressed

    private void btnRefreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefreshActionPerformed
        dataController.loadTable();
    }//GEN-LAST:event_btnRefreshActionPerformed

    private void btnTambahActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnTambahActionPerformed
        if (toolbarMode == TOOLBAR_BROWSE) {
            dataController.performTambahEx();            
            switchToolbar(TOOLBAR_OK_CANCEL);
        }else if (toolbarMode == TOOLBAR_OK_CANCEL){
            dataController.performOK();
            switchToolbar(TOOLBAR_BROWSE);
        }
        
    }//GEN-LAST:event_btnTambahActionPerformed

    private void btnUbahActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUbahActionPerformed
        if (toolbarMode == TOOLBAR_BROWSE) {
            dataController.performUbahEx();            
            switchToolbar(TOOLBAR_OK_CANCEL);
        }else if (toolbarMode == TOOLBAR_OK_CANCEL){
            dataController.performCancel();
            switchToolbar(TOOLBAR_BROWSE);
        }
    }//GEN-LAST:event_btnUbahActionPerformed

    private void btnHapusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnHapusActionPerformed
        dataController.performHapus();
    }//GEN-LAST:event_btnHapusActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton btnFilter;
    private javax.swing.JButton btnHapus;
    private javax.swing.JButton btnRefresh;
    private javax.swing.JButton btnRefresh1;
    private javax.swing.JButton btnRefresh2;
    private javax.swing.JButton btnRefresh3;
    private javax.swing.JButton btnRefresh4;
    private javax.swing.JToggleButton btnSemua;
    private javax.swing.JButton btnTambah;
    private javax.swing.JButton btnUbah;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToolBar tbarUtama;
    private javax.swing.JTable tblData;
    // End of variables declaration//GEN-END:variables
}
