/*
 * LoginDialog.java
 *
 * Created on 21 Maret 2008, 21:46
 */
package core.system;

import core.system.LoggingWindow;
import core.system.MainFrame;
import core.system.Startup;
import core.*;
import core.auth.Authentication;
import core.system.InputPemakai;
import core.gui.ComboBoxController;
import core.system.ApplicationInfo;
import core.system.DB;
import javax.swing.JOptionPane;

/**
 *
 * @author  PRAM WEE
 */
public class LoginDialog extends javax.swing.JDialog {

    /** A return status code - returned if Cancel button has been pressed */
    public static final int RET_CANCEL = 0;
    /** A return status code - returned if OK button has been pressed */
    public static final int RET_OK = 1;
    private static LoginDialog instance;
    private ComboBoxController controllerPemakai = null;

    public static LoginDialog getInstance() {
        if (instance == null) {
            instance = new LoginDialog(MainFrame.getInstance(), true);
        }
        return instance;
    }
    public static String idpemakai="id";

    /** Creates new form LoginDialog */
    public LoginDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        controllerPemakai = new ComboBoxController(cboNama);
        controllerPemakai.loadData("select "+idpemakai+",nama from pemakai");
        setTitle(ApplicationInfo.TITLE);
        lblTitle.setText(ApplicationInfo.TITLE);
        LoggingWindow.getInstance().addToLog("Login Started");
        lblStorage.setVisible(false);
        cboStorage.setVisible(false);
    }

    /** @return the return status of this dialog - one of RET_OK or RET_CANCEL */
    public int getReturnStatus() {
        return returnStatus;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        txtPassword = new javax.swing.JPasswordField();
        jLabel3 = new javax.swing.JLabel();
        okButton1 = new javax.swing.JButton();
        lblKeterangan = new javax.swing.JLabel();
        cboNama = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        txtNamaLengkap = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        lblTitle = new javax.swing.JLabel();
        lblStorage = new javax.swing.JLabel();
        cboStorage = new javax.swing.JComboBox();

        setTitle("Flexible ANP");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setMnemonic('l');
        okButton.setText("Login");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setMnemonic('x');
        cancelButton.setText("Exit");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Identitas");

        jLabel1.setText("Password");

        jLabel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 24));
        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/system/images/User.jpg"))); // NOI18N
        jLabel3.setText("Selamat Datang");
        jLabel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel3.setOpaque(true);

        okButton1.setMnemonic('d');
        okButton1.setText("Daftar..");
        okButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButton1ActionPerformed(evt);
            }
        });

        lblKeterangan.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        lblKeterangan.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        cboNama.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cboNamaActionPerformed(evt);
            }
        });

        jLabel5.setText("Nama Lengkap");

        txtNamaLengkap.setEditable(false);

        jLabel6.setText("Keterangan");

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/system/images/EditProfile.jpg"))); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        lblTitle.setFont(new java.awt.Font("Tahoma", 1, 12));
        lblTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTitle.setText("Title");

        lblStorage.setText("Storage");

        cboStorage.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Microsoft OBDC", "MySQL", "XML" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel6))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(lblStorage)
                                    .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cboStorage, 0, 217, Short.MAX_VALUE)
                            .addComponent(lblKeterangan, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                            .addComponent(cboNama, 0, 217, Short.MAX_VALUE)
                            .addComponent(txtPassword, javax.swing.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                            .addComponent(txtNamaLengkap, javax.swing.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(cancelButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(okButton1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(66, 66, 66))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(lblTitle, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE))
                        .addGap(71, 71, 71)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblTitle)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cboNama, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtNamaLengkap, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(lblKeterangan, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblStorage)
                    .addComponent(cboStorage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 13, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(okButton1)
                    .addComponent(cancelButton))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-337)/2, (screenSize.height-386)/2, 337, 386);
    }// </editor-fold>//GEN-END:initComponents
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        if (Startup.getInstance().authenticate(cboNama.getItemAt(
                cboNama.getSelectedIndex()) + 
                "", txtPassword.getPassword())) {
            LoggingWindow.getInstance().addToLog("Login Success");
            Authentication.getInstance().getUserInfo().setLogin(true);
            Authentication.getInstance().getListener().userLogin();
            doClose(RET_OK);
        } else {
            LoggingWindow.getInstance().addToLog("Login Failed");
            JOptionPane.showMessageDialog(this, 
                    "Maaf, password Anda tidak sesuai. Ulan gi lagi",
                    "Password salah", JOptionPane.ERROR_MESSAGE);
            txtPassword.requestFocus();
        }
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        //doClose(RET_CANCEL);
        DB.getInstance().shutdownDatabase();
        System.exit(0);
    }//GEN-LAST:event_cancelButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
        
    }//GEN-LAST:event_closeDialog

    private void okButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButton1ActionPerformed
        if (PrivilegeDialog.getInstance().isCorrect()) {
            LoggingWindow.getInstance().addToLog("Register New User");
            InputPemakai.getInstance().setPemakai(-1);
            InputPemakai.getInstance().setVisible(true);
            setVisible(true);
        }
    }//GEN-LAST:event_okButton1ActionPerformed

    private void cboNamaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cboNamaActionPerformed
        if (cboNama.getSelectedIndex() >= 0) {
            LoggingWindow.getInstance().addToLog("User Selected");
            String detail[][] = DB.getInstance().getDataSet("select namaLengkap,keterangan,password from pemakai where nama='" + cboNama.getItemAt(cboNama.getSelectedIndex()) + "'", false);
            txtNamaLengkap.setText(detail[0][0]);
            lblKeterangan.setText(detail[0][1]);
            txtPassword.requestFocus();
            if(Startup.BYPASS_PASSWORD) txtPassword.setText(detail[0][2]);
        }
    }//GEN-LAST:event_cboNamaActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (PrivilegeDialog.getInstance().isCorrect()) {
            LoggingWindow.getInstance().addToLog("Edit Profile");
            InputPemakai.getInstance().setPemakai(Integer.parseInt(""+controllerPemakai.getAutoIdFromSelectedIndex()));
            InputPemakai.getInstance().setVisible(true);
            setVisible(true);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void doClose(int retStatus) {
        if (retStatus != RET_CANCEL) {
            returnStatus = retStatus;
            setVisible(false);
            dispose();
        } else {
            JOptionPane.showMessageDialog(this, "Anda harus login sebelum menggunakan program ini", "Login", JOptionPane.INFORMATION_MESSAGE);
        }
    }

    @Override
    public void setVisible(boolean b) {
        if (b) {
            controllerPemakai.reload();
        } else {
            txtPassword.setText("");
        }
        super.setVisible(b);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox cboNama;
    private javax.swing.JComboBox cboStorage;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel lblKeterangan;
    private javax.swing.JLabel lblStorage;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JButton okButton;
    private javax.swing.JButton okButton1;
    private javax.swing.JTextField txtNamaLengkap;
    private javax.swing.JPasswordField txtPassword;
    // End of variables declaration//GEN-END:variables
    private int returnStatus = RET_CANCEL;
}
